﻿ItemEnchantApplication = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceHook-2.1")

local Items = {
	--[[ Rogue love
	]]
	[6947]	= true,		-- Instant Poison
	[6949]	= true,		-- Instant Poison II
	[6950]	= true,		-- Instant Poison III
	[8926]	= true,		-- Instant Poison IV
	[8927]	= true,		-- Instant Poison V
	[8928]	= true,		-- Instant Poison VI
	[3775]	= true,		-- Crippling Poison
	[3776]	= true,		-- Crippling Poison II
	[2892]	= true,		-- Deadly Poison
	[2893]	= true,		-- Deadly Poison II
	[8984]	= true,		-- Deadly Poison III
	[8985]	= true,		-- Deadly Poison IV
	[20844] = true,		-- Deadly Poison V
	[5237]	= true,		-- Mind-numbing Poison
	[6951]	= true,		-- Mind-numbing Poison II
	[9186]	= true,		-- Mind-numbing Poison III
	[10918]	= true,		-- Wound Poison
	[10920]	= true,		-- Wound Poison II
	[10921]	= true,		-- Wound Poison III
	[10922]	= true,		-- Wound Poison IV
	--[[ Sharpening Stones
	]]
	[23122] = true,		-- Consecrated Sharpening Stone
	[18262] = true,		-- Elemental Sharpening Stone
	[2863]	= true,		-- Coarse Sharpening Stone
	[12404] = true,		-- Dense Sharpening Stone
	[2871]	= true,		-- Heavy Sharpening Stone
	[2862]	= true,		-- Rough Sharpening Stone
	[7964]	= true,		-- Solid Sharpening Stone
	--[[ Weightstones
	]]
	[3240]	= true,		-- Coarse Weightstone
	[12643] = true,		-- Dense Weightstone
	[3241]	= true,		-- Heavy Weightstone
	[3239]	= true,		-- Rough Weightstone
	[7965]	= true,		-- Solid Weightstone	
	--[[ Wizard oils
	]]
	[23123]	= true,		-- Blessed Wizard Oil
	[20749]	= true,		-- Brilliant Wizard Oil
	[20746]	= true,		-- Lesser Wizard Oil
	[20744]	= true,		-- Minor Wizard Oil
	[20750]	= true,		-- Wizard Oil
	--[[ Mana oils
	]]
	[20748]	= true,		-- Brilliant Mana Oil
	[20747]	= true,		-- Lesser Mana Oil
	[20745]	= true,		-- Minor Mana Oil
	--[[ Fishing lures
	]]
	[6533]	= true,		-- Aquadynamic Fish Attractor
	[6532]	= true,		-- Bright Baubles
	[6530]	= true,		-- Nightcrawlers
	[6529]	= true,		-- Shiny Bauble
}

local g = AceLibrary("Gratuity-2.0")
g:Erase() 

function ItemEnchantApplication:OnInitialize()
self.revision = tonumber(string.sub("$Rev: 23237 $", 7, -3))
self.version = self.version .. " |cffff8888r"..self.revision.."|r"
self:RegisterChatCommand({"/ItemEnchantApplication", "/iea"})
end

function ItemEnchantApplication:OnEnable()
--self:SecureHook("UseItemByName")
self:SecureHook("UseAction")
self:SecureHook("UseContainerItem")
self.frame = ItemEnchantApplication:Frame()
end


function ItemEnchantApplication:UseContainerItem()
if(IsAddOnLoaded("OneBag")) then
local s, b = string.match(this:GetName(), "(%d+)Item(%d+)")
local link = self:GetID(GetContainerItemLink(s, b))
if Items[link] then
	self.frame.Main:SetAttribute("bag", b)
	self.frame.Main:SetAttribute("slot", s)
	self.frame.Main:SetAttribute("item", name)
	self.frame.Off:SetAttribute("bag", b)
	self.frame.Off:SetAttribute("slot", s)
	self.frame.Off:SetAttribute("item", name)
	if(SpellIsTargeting()) then
		self.frame.Main:SetAttribute("type", nil)
		self.frame.Off:SetAttribute("type", nil)
	end
	self.frame:Show()
	self.frame:SetPoint("RIGHT", this, "LEFT")
end
end
end

function ItemEnchantApplication:UseAction()
if(IsAddOnLoaded("Bartender3")) then
local s = string.match(this:GetName(), "Button(%d+)")
if not IsConsumableAction(s) then return end
g:SetAction(s)
s = g:GetLine(1, false)
local _, itemlink = GetItemInfo(s)
link = self:GetID(itemlink)
local b, s = self:BagPos(itemlink)
if Items[link] then
	self.frame.Main:SetAttribute("bag", b)
	self.frame.Main:SetAttribute("slot", s)
	self.frame.Main:SetAttribute("item", name)
	self.frame.Off:SetAttribute("bag", b)
	self.frame.Off:SetAttribute("slot", s)
	self.frame.Off:SetAttribute("item", name)
	if(SpellIsTargeting()) then
		self.frame.Main:SetAttribute("type", nil)
		self.frame.Off:SetAttribute("type", nil)
	end
	self.frame:Show()
	self.frame:SetPoint("RIGHT", this, "LEFT")
end
end 
end

function ItemEnchantApplication:GetID(item)
if type(item) == "number" then return item
elseif type(item) == "string" then
local id = string.match(item, "item:(%d+):%d+:%d+:%d+")
return tonumber(id)
end
end 

function ItemEnchantApplication:BagPos(ItemLink)
  for bag=0,4 do
    for slot=1,GetContainerNumSlots(bag) do
      if (GetContainerItemLink(bag,slot)) == ItemLink then
		return bag, slot
    end
  end
end
end 
